#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int r(int a)
{
    return (a+4)%4;
}

int fc(char c)
{
    if (c == '<') return '>';
    if (c == '>') return '<';
    if (c == '/') return '\\';
    if (c == '\\') return '/';
    return c;
}

int rc(char c, int rot)
{
    static char *cr = "^>v<|-|-/\\/\\";
    int i = 0;
    while (cr[i]) {
	    if (cr[i] == c) return cr[4*(i/4) + (i+rot)%4];
	i++;
    }
    return c;
}

int main(int argc, char **argv)
{
    char disp[200][200];
    int rot, flip;
    int ret, size, i, j;
    while (1) {
	ret = scanf("%d\n", &size);
	if (ret < 1) break;
	for (i=0; i<size; i++) {
	    fgets(disp[i], 150, stdin);
	    disp[i][size] = 0;
	}

	rot = 0; flip = 1;

	while (1) {
	    int c = getc(stdin);
	    if (c == '\n') break;
	    if (c == '<') rot = r(rot - 1);
	    if (c == '>') rot = r(rot + 1);
	    if (c == '-') { flip = -flip; if (rot % 2 == 0) rot = r(rot+2); }
	    if (c == '|') { flip = -flip; if (rot % 2) rot = r(rot+2); }
	    if (c == '\\') { flip = -flip; if (rot % 2) rot = r(rot+1); else rot = r(rot-1); }
	    if (c == '/') { flip = -flip; if (rot % 2) rot = r(rot-1); else rot = r(rot+1); }
	    //printf("flip %d rot %d\n", flip, rot);
	}

	for (i = 0; i<size; i++) {
	    for (j=0; j<size; j++) {
		int ti,tj,ii,jj;
		ti = i; tj = j;
		//if (flip < 0) { tj = size - 1 - tj; }
		if (rot == 0) { ii = ti; jj = tj; }
		if (rot == 1) { ii = size - 1 - tj; jj = ti; }
		if (rot == 2) { ii = size - 1 - ti; jj = size - 1 - tj; }
		if (rot == 3) { ii = tj; jj = size - 1 - ti; }
		if (flip < 0) jj = size - 1 - jj;
		char c = disp[ii][jj];
		if (flip < 0) c = fc(c);
		c = rc(c, rot);
		putc(c, stdout);
	    }
	    putc('\n', stdout);
	}

    }
    return 0;
}
